import { camelize } from 'camelize-object-key';
import { Meta, Canvas, Story, ArgsTable } from '@storybook/addon-docs/blocks';
import BlockSpecs from './block-specs';
import store from '@/.storybook/store';
import { addControls, initJsonKnobs } from '@/.storybook/helpers';

export const argTypes = {
	appearance: {
		control: {
			type: 'select',
			options: ['primary', 'secondary', 'tertiaty'], // TODO: `tertiaty` => `tertiary`
		},
	},
};

export const controls = {
	color: [
		'mobileBackgroundColor',
		'desktopBackgroundColor',
		'headingColor',
		'headingColorDesktop',
		'copyColor',
		'copyColorDesktop',
	],
	number: [],
	json: ['items'],
};

<Meta title="Specs" component={BlockSpecs} argTypes={addControls(argTypes, controls)} />

# Specs

This module is used on the product pages.

It is used to show a table of specifications of a product.

export const Template = (args, { argTypes }) => {
	initJsonKnobs(args, argTypes, controls.json);
	return {
		props: Object.keys(argTypes),
		components: { BlockSpecs },
		template: '<block-specs v-bind="$props" />',
		store,
	};
};

export const items = [
  { name: 'Room size coverage', value: '<p>Up to 600 sq. ft. (55.74 m²)</p>', value_ca: [] },
  { name: 'Handle', value: '<p>Leather</p>', value_ca: [] },
  {
    name: 'Filters',
    value:
      '<p>1 PECO-Filter — recommended replacement every 6 months</p><p>1 Pre-Filter — recommended replacement every 3 months</p>',
    value_ca: [],
  },
  {
    name: 'Power consumption',
    value: '<p>Lowest speed — 20 W/h  |  Highest speed — 80 W/h</p><p>(3-prong power plug)</p>',
    value_ca: [],
  },
  { name: 'Sound Levels', value: '<p>Lowest speed — 41 dBa  |  Highest speed — 65 dBa</p>', value_ca: [] },
  { name: 'App enabled', value: '<p>iOS &amp; Android </p>', value_ca: [] },
  { name: 'WiFi enabled', value: '<p>2.4 GHz</p>', value_ca: [] },
  { name: 'Cord length', value: '<p>64“ (162.5 cm)</p>', value_ca: [] },
  { name: 'Size', value: '<p>23” (53.4cm) high x 8.25” (20.95cm) wide</p>', value_ca: [] },
  { name: 'Weight', value: '<p>18 lbs (8kg)</p>', value_ca: [] },
  { name: 'Warranty', value: '<p>2-year limited warranty</p>', value_ca: [] },
];

<Canvas withSource="none">
	<Story
		name="default"
		args={{
			appearance: 'primary',
			desktopBackgroundColor: '',
			heading: 'Air tech specs',
			headingDesktop: '',
			items: camelize(items),
			mobileBackgroundColor: '',
			nameWidth: 40,
			valueWidth: 60,
		}}
	>
		{Template.bind({})}
	</Story>
</Canvas>

## Vue Component Props

<ArgsTable of={BlockSpecs} />
